var jsdom	= require('jsdom'),
	path	= require('path'),
	cs		= require('../change_case');

var f;

module.exports=function(fu){
	f=fu;
	var clc=f.clc,
		wd=f.workingdir,
		cfg,
		id;
		
	try {
		cfg=require(wd+'esm.json');
	} catch(err) {
		cfg=null;
	}
	if (cfg) {
		id=cs.camel(cfg.name);
	}
	//var id=cs.camel(cfg.name);
	
	return f.test=function(cb){
		if (!id) {
			console.log(clc.error('no esm package'));
			return;
		}
		var scri=[],
			scrie=[];
		
		f.config.emobiqApp.res.forEach(function(v){
			scri.push(v);
		});	
		scri.push('file://'+path.resolve('./'+cfg.dir.dist.app)+'/'+id+'.js');
		
		f.config.emobiqEditor.res.forEach(function(v){
			scrie.push(v);
		});
		scrie.push('file://'+path.resolve('./'+cfg.dir.dist.editor)+'/'+id+'.js');
		
		var appTest=function(window,self,done){
			//console.log('app==>',self);
			done();
		};
		var editorTest=function(window,self,done){
			//console.log('editor==>',self);
			done();
		}
		if (!cb) {
			console.log(clc.empty('app script test...'));
		}
		tests({
				scripts:scri,
				id:id,
				test:appTest,
				title:'app'
			},function(e){
				if(e){
					if (cb) { cb(e); return; }
					console.error(e);
					//console.log(clc.red(e.toString()));
					return;
				}
				console.log(clc.empty(' app test completed'));
				if (!cb) {
					console.log(clc.empty('editor script test...'));
				}
				tests({
						scripts:scrie,
						id:id,
						test:editorTest,
						title:'editor'
					},function(e){
						if(e && !cb){
							//console.log(clc.red(e.toString()));
							console.error(e);
							return;
						}
						if(cb){ cb(e); return; }
						console.log(clc.empty(' editor test completed'));
					});
			});
	};
};

function tests(opts,cb){
	var scri=opts.scripts,
		test=opts.test,
		id=opts.id;
		title=opts.title;
	if (!cb) { console.log(clc.empty(title+' test start')); }
	//jsdom.env(
	//	'<div></div>',
	//	{
	//		scripts: scri,
	//		done: function (e, window) {
	//			//console.log(window.document.documentElement.outerHTML);
	//			if (e) {
	//				if (!cb) { console.log(clc.red(e.toString())); }
	//				else { cb(e); }
	//				window.close();
	//				return;
	//			}
	//			try {
	//				var x=window[id];
	//				if (!x) {
	//					console.log(clc.empty(' empty '+title+' script'));
	//				}
	//				test(window,x,function(e){
	//					if(cb){ cb(e); }
	//					else {
	//						console.log(clc.empty(title+' test complete'));
	//					}
	//				});
	//			} catch(ee) {
	//				if (!cb) { console.log(clc.red(ee.toString())); }
	//				else { cb(ee); }
	//				window.close();
	//				return;
	//			}
	//			window.close();
	//		}
	//	});
	
	jsdom.env({
		html:'<div></div>',
		scripts: scri,
		created:function(e, window){
			window.addEventListener("error", function (event) {
				console.error("script error!!", event.error);
				//process.exit();
			});
			navigator = window.navigator;
			window.localStorage = window.sessionStorage = {
				getItem: function (key) {
					return this[key];
				},
				setItem: function (key, value) {
					this[key] = value;
				}
			};	
		},
		done: function (e, window) {
			if (f.p.options && f.p.options.show) {
				console.log('html ==>',window.document.documentElement.outerHTML);
			}
			if (e) {
				if (!cb) { console.log(clc.red(e.toString())); }
				else { cb(e); }
				window.close();
				return;
			}
			try {
				var x=window[id];
				if (!x) {
					//console.log(clc.empty(' no exported '+title+' script'));
				}
				test(window,x,function(e){
					if(cb){ cb(e); }
					else {
						console.log(clc.empty(title+' test completed'));
					}
				});
			} catch(ee) {
				if (!cb) { console.log(clc.red(ee.toString())); }
				else { cb(ee); }
				window.close();
				return;
			}
			window.close();
		}
	});
}